diff -uwr source/scripts/dp88_buildingScripts.cpp 4.0/source/scripts/dp88_buildingScripts.cpp
--- source/scripts/dp88_buildingScripts.cpp	2011-04-11 13:06:52.000000000 +0800
+++ 4.0/source/scripts/dp88_buildingScripts.cpp	2011-10-25 15:38:28.234375000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Building scripts for the Apocalypse Rising mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,7 +9,6 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 // Include files
 #include "general.h"
 #include "scripts.h"
@@ -19,9 +17,10 @@
 #include "dp88_buildingScripts.h"
 #include "definition.h"
 #include "BaseControllerClass.h"
-
-
-
+#include "WarFactoryGameObj.h"
+#include "AirFactoryGameObj.h"
+#include "RefineryGameObj.h"
+#include "PurchaseSettingsDefClass.h"
 
 /*------------------------
 Building Controller Script
@@ -679,15 +678,46 @@
 
 void dp88_buildingScripts_weakpoint_disableVehiclePurchase::applyEffect ( GameObject* obj, GameObject* parent )
 {
-	Set_Can_Generate_Vehicles ( Get_Object_Type(parent), false );
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_VehicleFactoryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_VehicleFactoryGameObj()->Set_Disabled(true);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(true);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(true);
+	}
 }
 
 void dp88_buildingScripts_weakpoint_disableVehiclePurchase::reverseEffect ( GameObject* obj, GameObject* parent )
 {
-	Set_Can_Generate_Vehicles ( Get_Object_Type(parent), true );
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_VehicleFactoryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_VehicleFactoryGameObj()->Set_Disabled(false);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(false);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(false);
+	}
 }
 
 
+/*------------------------
+Weakpoint - Disable Air Vehicle Purchase
+--------------------------*/
+
+void dp88_buildingScripts_weakpoint_disableAirVehiclePurchase::applyEffect ( GameObject* obj, GameObject* parent )
+{
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_AirFactoryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_AirFactoryGameObj()->Set_Disabled(true);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_AIR,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(true);
+	}
+}
+
+void dp88_buildingScripts_weakpoint_disableAirVehiclePurchase::reverseEffect ( GameObject* obj, GameObject* parent )
+{
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_AirFactoryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_AirFactoryGameObj()->Set_Disabled(false);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_AIR,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(false);
+	}
+}
 
 
 /*------------------------
@@ -705,8 +735,6 @@
 }
 
 
-
-
 /*------------------------
 Weakpoint - Disable Radar
 --------------------------*/
@@ -722,6 +750,26 @@
 }
 
 
+/*------------------------
+Weakpoint - Disable Refinery
+--------------------------*/
+
+void dp88_buildingScripts_weakpoint_disableRefinery::applyEffect ( GameObject* obj, GameObject* parent )
+{
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_RefineryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_RefineryGameObj()->Block_Harvester_Spawn();
+	}
+}
+
+void dp88_buildingScripts_weakpoint_disableRefinery::reverseEffect ( GameObject* obj, GameObject* parent )
+{
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_RefineryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_RefineryGameObj()->Allow_Harvester_Spawn();
+	}
+}
+
 
 
 /*------------------------
@@ -1251,7 +1299,10 @@
 
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableSoldierPurchase> dp88_buildingScripts_weakpoint_disableSoldierPurchase_Registrant( "dp88_buildingScripts_weakpoint_disableSoldierPurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableVehiclePurchase> dp88_buildingScripts_weakpoint_disableVehiclePurchase_Registrant( "dp88_buildingScripts_weakpoint_disableVehiclePurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
+ScriptRegistrant<dp88_buildingScripts_weakpoint_disableAirVehiclePurchase> dp88_buildingScripts_weakpoint_disableAirVehiclePurchase_Registrant( "dp88_buildingScripts_weakpoint_disableAirVehiclePurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableBasePower> dp88_buildingScripts_weakpoint_disableBasePower_Registrant( "dp88_buildingScripts_weakpoint_disableBasePower", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
+ScriptRegistrant<dp88_buildingScripts_weakpoint_disableRadar> dp88_buildingScripts_weakpoint_disableRadar_Registrant( "dp88_buildingScripts_weakpoint_disableRadar", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
+ScriptRegistrant<dp88_buildingScripts_weakpoint_disableRefinery> dp88_buildingScripts_weakpoint_disableRefinery_Registrant( "dp88_buildingScripts_weakpoint_disableRefinery", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 
 ScriptRegistrant<dp88_buildingScripts_functionMoneyTrickle> dp88_buildingScripts_functionMoneyTrickle_Registrant( "dp88_buildingScripts_functionMoneyTrickle", "creditsPerSec=3.0:float" );
 ScriptRegistrant<dp88_buildingScripts_functionSpawnTeamZone> dp88_buildingScripts_functionSpawnTeamZone_Registrant( "dp88_buildingScripts_functionSpawnTeamZone", "scriptZonePreset_team0:string,scriptZonePreset_team1:string,scriptZonePreset_team2:string,scriptZoneBone:string,scriptZoneSize:vector3,destroyZoneWhenDisabled=1:int" );
diff -uwr source/scripts/dp88_buildingScripts.h 4.0/source/scripts/dp88_buildingScripts.h
--- source/scripts/dp88_buildingScripts.h	2011-03-15 13:53:18.000000000 +0800
+++ 4.0/source/scripts/dp88_buildingScripts.h	2011-10-22 18:09:56.484375000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Building scripts for the Apocalypse Rising mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 
 // Define building child types
@@ -157,7 +157,15 @@
 };
 
 
+/*------------------------
+Weakpoint - Disable Air Vehicle Purchase
+--------------------------*/
 
+class dp88_buildingScripts_weakpoint_disableAirVehiclePurchase : public MinorWeakpointScriptClass
+{
+	void applyEffect ( GameObject *obj, GameObject *parent );
+	void reverseEffect ( GameObject *obj, GameObject *parent );
+};
 
 /*------------------------
 Weakpoint - Disable Base Power
@@ -183,6 +191,15 @@
 };
 
 
+/*------------------------
+Weakpoint - Disable Refinery
+--------------------------*/
+
+class dp88_buildingScripts_weakpoint_disableRefinery : public MinorWeakpointScriptClass
+{
+	void applyEffect ( GameObject *obj, GameObject *parent );
+	void reverseEffect ( GameObject *obj, GameObject *parent );
+};
 
 
 /*------------------------
diff -uwr source/scripts/dp88_customAI.cpp 4.0/source/scripts/dp88_customAI.cpp
--- source/scripts/dp88_customAI.cpp	2011-04-11 14:28:10.000000000 +0800
+++ 4.0/source/scripts/dp88_customAI.cpp	2011-10-22 21:53:45.773437500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Experimental vehicle AIs
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,13 +9,12 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 // Include files
 #include "general.h"
 #include "scripts.h"
 #include "engine.h"
 #include "dp88_customAI.h"
-
+#include "VehicleGameObj.h"
 
 /*------------------------
 Base class for custom AI's
@@ -110,7 +108,16 @@
 	// Priority is 0 if the unit is dead or not on teams 0 or 1
 	if ( ( Commands->Get_Health ( target ) + Commands->Get_Shield_Strength ( target ) ) == 0
 		|| ( Commands->Get_Player_Type ( target ) != 0 && Commands->Get_Player_Type ( target ) != 1 ) )
+	{
+		if ( debug ) fprintf ( debugFile, "Target %d is dead or unteamed, ignoring\n", Commands->Get_ID(target));
 		return 0.0;
+	}
+
+	if ( Is_Vehicle(target) && !IsVehicleAIEnabled(target->As_VehicleGameObj()) && IsVehicleEmpty(target->As_VehicleGameObj()) )
+	{
+		if ( debug ) fprintf ( debugFile, "Target %d is an empty, non-AI vehicle, ignoring\n", Commands->Get_ID(target));
+		return 0.0;
+	}
 
 	float priority = 0.0;
 
@@ -200,6 +207,22 @@
 }
 
 
+bool dp88_customAI::IsVehicleEmpty( VehicleGameObj* vobj )
+{
+	if ( vobj == NULL )
+		return false;
+	return (vobj->Get_Occupant_Count() == 0);
+}
+
+
+bool dp88_customAI::IsVehicleAIEnabled( VehicleGameObj* vobj )
+{
+	if ( vobj == NULL )
+		return false;
+	return (vobj->Get_Action()->Is_Acting());
+}
+
+
 
 /*------------------------
 Offensive Tank AI
@@ -419,7 +442,7 @@
 	// If this is our current target update last seen time and priority
 	if ( Commands->Get_ID ( enemy ) == targetID )
 	{
-		if ( debug ) fprintf( debugFile, "Enemy is current target, last seen time and priority\n" );
+		if ( debug ) fprintf( debugFile, "Enemy is current target, last seen time and priority updated\n" );
 		targetLastSeen = (int)time(NULL);
 		targetPriority = getPriority(obj, enemy);
 		return;
@@ -487,9 +510,10 @@
 				|| ( Commands->Get_Health ( target ) + Commands->Get_Shield_Strength ( target ) <= 0 )
 				|| !checkTeam ( obj, target )
 				|| !checkRange ( obj, target, primary_target )
-				|| (int)time(NULL) - targetLastSeen > 3 )	// Not seen target for 3 seconds
+				|| (int)time(NULL) - targetLastSeen > 3
+				|| ( Is_Vehicle(target) && !IsVehicleAIEnabled(target->As_VehicleGameObj()) && IsVehicleEmpty(target->As_VehicleGameObj()) ) )
 			{
-				if ( debug ) fprintf ( debugFile, "Target no longer valid, ceasing attack.\n" );
+				if ( debug ) fprintf ( debugFile, "Target %d no longer valid, ceasing attack.\n", targetID);
 				targetID = 0;
 				targetPriority = 0.0f;
 				targetLastSeen = 0;
diff -uwr source/scripts/dp88_customAI.h 4.0/source/scripts/dp88_customAI.h
--- source/scripts/dp88_customAI.h	2010-09-19 13:19:04.000000000 +0800
+++ 4.0/source/scripts/dp88_customAI.h	2011-10-22 19:50:31.665039000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Experimental vehicle AIs
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 
 #define TIMER_CHECK_TARGET 100778801
@@ -85,6 +85,10 @@
 	virtual float getPriority( GameObject *obj, GameObject *target );
 	virtual float getPriority( GameObject *obj, int target_id );
 	bool getPrimary ( GameObject *target );
+
+	/* Utility functions for both priority calculations and AI scripts to utilise */
+	virtual bool IsVehicleEmpty( VehicleGameObj* vobj );
+	virtual bool IsVehicleAIEnabled( VehicleGameObj* vobj );
 };
 
 
diff -uwr source/scripts/dp88_custom_timer_defines.h 4.0/source/scripts/dp88_custom_timer_defines.h
--- source/scripts/dp88_custom_timer_defines.h	2011-03-15 13:53:18.000000000 +0800
+++ 4.0/source/scripts/dp88_custom_timer_defines.h	2011-10-25 07:50:47.753906200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Custom and Timer number definitions for the ApocRising total conversion mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 
 /****************************
@@ -83,6 +83,8 @@
 #define CUSTOM_REMOTECONTROL_DESTROYED				1144070003		// Sent by a remote controlled vehicle when it is destroyed
 #define CUSTOM_REMOTECONTROL_CONSOLEID				1144070004
 #define CUSTOM_REMOTECONTROL_CONSOLEACK				1144070005
+#define CUSTOM_REMOTECONTROL_DISABLED				1144070006		// Send to a remote control console to disable it
+#define CUSTOM_REMOTECONTROL_ENABLED				1144070007		// Send to a remote control console to enable it
 
 
 
@@ -140,3 +142,4 @@
 #define TIMER_REMOTECONTROL_TIMEOUT					2244070001		// Timer to time out a remote vehicle purchase if we don't get confirmation within the deadline
 #define TIMER_REMOTECONTROL_DRIVERENTER				2244070002		// Timer to place driver into remove vehicle once transitions are enabled
 #define TIMER_REMOTECONTROL_DRIVEREXIT				2244070003		// Timer to return driver from a dead remote vehicle
\ No newline at end of file
+#define TIMER_REMOTECONTROL_CHARGETICK				2244070004		// Timer to count down charge time
\ No newline at end of file
diff -uwr source/scripts/dp88_misc.cpp 4.0/source/scripts/dp88_misc.cpp
--- source/scripts/dp88_misc.cpp	2011-04-11 11:56:44.000000000 +0800
+++ 4.0/source/scripts/dp88_misc.cpp	2011-10-11 23:03:39.628906200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Miscellaneous scripts by danpaul88
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,7 +9,6 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 #include "general.h"
 #include "dp88_misc.h"
 #include "dp88_custom_timer_defines.h"
@@ -1333,9 +1331,12 @@
 	float points = ((bRepair) ? repairPoints : damagePoints) * amount;
 	float money = ((bRepair) ? repairMoney : damageMoney) * amount;
 
+	// Is this player an APB spy?
+	bool bSpy = ( Find_Script_On_Object(damager, "RA_Infantry_Spy") != NULL );
+
 	// Repaired other team or damaged own team? That would be negative points and no
-	// money for you then...
-	if ( (Get_Object_Type(obj) == Get_Object_Type(damager)) != bRepair )
+	// money for you then... unless your spy, then the logic is inverted...
+	if ( bSpy ^ ((Get_Object_Type(obj) == Get_Object_Type(damager)) != bRepair) )
 	{
 		points *= -1.0f;
 		money = 0.0f;
diff -uwr source/scripts/dp88_misc.h 4.0/source/scripts/dp88_misc.h
--- source/scripts/dp88_misc.h	2011-03-15 13:53:18.000000000 +0800
+++ 4.0/source/scripts/dp88_misc.h	2011-10-14 22:27:32.112304600 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Miscellaneous scripts by danpaul88
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 #include "scripts.h"
 #include "engine.h"
diff -uwr source/scripts/dp88_securitySystem.cpp 4.0/source/scripts/dp88_securitySystem.cpp
--- source/scripts/dp88_securitySystem.cpp	2010-04-14 10:13:20.000000000 +0800
+++ 4.0/source/scripts/dp88_securitySystem.cpp	2011-10-11 23:03:38.137695300 +0800
@@ -1,9 +1,5 @@
 /*	Renegade Scripts.dll
-	
-	Scripts to create a security system based on cameras, security doors and
-	internal defenses.
-
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -13,7 +9,6 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 #include "general.h"
 #include "scripts.h"
 #include "engine.h"
diff -uwr source/scripts/dp88_securitySystem.h 4.0/source/scripts/dp88_securitySystem.h
--- source/scripts/dp88_securitySystem.h	2010-04-14 10:13:24.000000000 +0800
+++ 4.0/source/scripts/dp88_securitySystem.h	2011-10-14 22:27:32.145507800 +0800
@@ -1,9 +1,5 @@
 /*	Renegade Scripts.dll
-	
-	Scripts to create a security system based on cameras, security doors and
-	internal defenses.
-
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -13,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 
 #define SECURITYSYSTEM_TIMER_POSTINITIALISE 1450001
diff -uwr source/scripts/dp88_veterancy.cpp 4.0/source/scripts/dp88_veterancy.cpp
--- source/scripts/dp88_veterancy.cpp	2011-04-11 14:28:10.000000000 +0800
+++ 4.0/source/scripts/dp88_veterancy.cpp	2011-10-23 09:34:51.542968900 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Veterancy system by danpaul88
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,7 +9,6 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 // Include files
 #include "general.h"
 #include "dp88_veterancy.h"
@@ -1002,3 +1000,88 @@
 ScriptRegistrant<dp88_linkVetPoints> dp88_linkVetPoints_Registrant(
 	"dp88_linkVetPoints",
 	"parentObjectId=0:int");
+
+
+
+
+
+
+
+
+/*------------------------
+Veterancy - Promotion health/armour boost
+--------------------------*/
+
+void dp88_veterancyPromotionHealthArmourIncrease::Created( GameObject *obj )
+{
+	// Set initial veterancy level
+	m_veterancyLevel = 0;
+}
+
+
+void dp88_veterancyPromotionHealthArmourIncrease::Custom( GameObject *obj, int type, int param, GameObject *sender )
+{
+	// If custom == CUSTOM_VETERANCY_PROMOTED update veterancyLevel
+	if ( type == CUSTOM_VETERANCY_PROMOTED )
+	{
+		int oldVeterancy = m_veterancyLevel;
+		m_veterancyLevel = param;
+
+		int healthChange = 0;
+		int armourChange = 0;
+
+		// Handle promotions
+		if ( oldVeterancy < m_veterancyLevel )
+		{
+			// Elite promotion
+			if ( m_veterancyLevel == 2 )
+			{
+				healthChange += Get_Int_Parameter ( "eliteHealthIncrease" );
+				armourChange += Get_Int_Parameter ( "eliteArmourIncrease" );
+			}
+
+			// Veteran promotion
+			if ( oldVeterancy == 0 )	// Must be either veteran OR elite now, so apply veteran bonus
+			{
+				healthChange += Get_Int_Parameter ( "veteranHealthIncrease" );
+				armourChange += Get_Int_Parameter ( "veteranArmourIncrease" );
+			}
+		}
+
+
+		// And demotions (specifically vehicles)
+		else
+		{
+			// Elite promotion
+			if ( oldVeterancy == 2 )
+			{
+				healthChange -= Get_Int_Parameter ( "eliteHealthIncrease" );
+				armourChange -= Get_Int_Parameter ( "eliteArmourIncrease" );
+			}
+
+			if ( m_veterancyLevel == 0 )	// Must have been either veteran OR elite, so remove veteran bonus
+			{
+				healthChange -= Get_Int_Parameter ( "veteranHealthIncrease" );
+				armourChange -= Get_Int_Parameter ( "veteranArmourIncrease" );
+			}
+		}
+
+		// Calculate new health/armour values - changing the max values might alter the
+		// current values so we calculate this first to avoid problems with this
+		int newHealth = (int)Commands->Get_Health(obj)+healthChange;
+		int newArmour = (int)Commands->Get_Shield_Strength(obj)+armourChange;
+
+		// Apply changes
+		Set_Max_Health ( obj, Commands->Get_Max_Health(obj)+healthChange );
+		Commands->Set_Health ( obj, (float)newHealth );
+		Set_Max_Shield_Strength ( obj, Commands->Get_Max_Shield_Strength(obj)+armourChange );
+		Commands->Set_Shield_Strength ( obj, (float)newArmour );
+	}
+}
+
+ScriptRegistrant<dp88_veterancyPromotionHealthArmourIncrease> dp88_veterancyPromotionHealthArmourIncrease_Registrant(
+	"dp88_veterancyPromotionHealthArmourIncrease",
+	"veteranHealthIncrease=0:int,"
+	"veteranArmourIncrease=0:int,"
+	"eliteHealthIncrease=0:int,"
+	"eliteArmourIncrease=0:int");
\ No newline at end of file
diff -uwr source/scripts/dp88_veterancy.h 4.0/source/scripts/dp88_veterancy.h
--- source/scripts/dp88_veterancy.h	2010-11-19 06:38:36.000000000 +0800
+++ 4.0/source/scripts/dp88_veterancy.h	2011-10-22 18:09:56.480468700 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Veterancy system by danpaul88
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 #include "scripts.h"
 #include "engine.h"
@@ -122,3 +122,14 @@
 	float lastInfantryPoints;
 	float lastVehiclePoints;
 };
\ No newline at end of file
+
+
+// Script to grant extra health / armour upon promotion
+class dp88_veterancyPromotionHealthArmourIncrease : public ScriptImpClass
+{
+	void Created( GameObject *obj );
+	void Custom( GameObject *obj, int type, int param, GameObject *sender );
+
+	private:
+		int m_veterancyLevel;
+};
\ No newline at end of file
diff -uwr source/scripts/engine.h 4.0/source/scripts/engine.h
--- source/scripts/engine.h	2010-04-14 10:13:24.000000000 +0800
+++ 4.0/source/scripts/engine.h	2011-10-14 22:27:32.064453100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Engine classes and calls
-	Copyright 2010 WhiteDragon(MDB), Joshua "NeoSaber" Kraft, Jonathan Wilson, Mark Sarau
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 #include "engine_common.h"
 #include "engine_vector.h"
 #include "engine_threading.h"
diff -uwr source/scripts/engine_3dre.h 4.0/source/scripts/engine_3dre.h
--- source/scripts/engine_3dre.h	2010-12-13 06:30:26.000000000 +0800
+++ 4.0/source/scripts/engine_3dre.h	2011-10-11 21:54:26.711914000 +0800
@@ -1,6 +1,5 @@
 /* Renegade Scripts.dll
-	Base 3D drawing related engine classes and calls
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_common.cpp 4.0/source/scripts/engine_common.cpp
--- source/scripts/engine_common.cpp	2011-08-09 11:12:30.000000000 +0800
+++ 4.0/source/scripts/engine_common.cpp	2011-10-11 23:03:34.733398400 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Engine call common definitions
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -172,11 +171,6 @@
 	return Exe;
 };
 
-void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
-{
-	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
-}
-
 SCRIPTS_API void* HookupAT3(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
 {
 	static const char relJumpOp = '\xE9';					
diff -uwr source/scripts/engine_common.h 4.0/source/scripts/engine_common.h
--- source/scripts/engine_common.h	2011-08-14 12:11:22.000000000 +0800
+++ 4.0/source/scripts/engine_common.h	2011-10-11 21:54:22.270507800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Engine call common definitions
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_def.cpp 4.0/source/scripts/engine_def.cpp
--- source/scripts/engine_def.cpp	2011-08-12 06:39:30.000000000 +0800
+++ 4.0/source/scripts/engine_def.cpp	2011-10-11 23:03:32.718750000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	General ingame data related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_def.h 4.0/source/scripts/engine_def.h
--- source/scripts/engine_def.h	2010-05-31 12:24:30.000000000 +0800
+++ 4.0/source/scripts/engine_def.h	2011-10-11 21:54:12.960937500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	General ingame data related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_dmg.cpp 4.0/source/scripts/engine_dmg.cpp
--- source/scripts/engine_dmg.cpp	2011-08-25 15:31:22.000000000 +0800
+++ 4.0/source/scripts/engine_dmg.cpp	2011-10-11 23:03:31.418945300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Classes and engine calls related to health, damage and repair
-	Copyright 2010 Jonathan Wilson, Mark Sararu, Joshua "NeoSaber" Kraft, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -29,6 +28,14 @@
 RENEGADE_FUNCTION
 ArmorType ArmorWarheadManager::Get_Armor_Type(const char*)
 AT3(0x00687750, 0x00686FF0, 0x005191A0);
+
+RENEGADE_FUNCTION
+WarheadType ArmorWarheadManager::Get_Warhead_Type(const char*)
+AT3(0x00687790, 0x00687030, 0x005191F0);
+
+RENEGADE_FUNCTION
+const char *ArmorWarheadManager::Get_Warhead_Name(WarheadType)
+AT3(0x006877E0, 0x00687080, 0x005192A0);
 #endif
 #ifndef TTLE_EXPORTS
 #include "Engine_Game.h"
diff -uwr source/scripts/engine_dmg.h 4.0/source/scripts/engine_dmg.h
--- source/scripts/engine_dmg.h	2010-05-31 12:27:14.000000000 +0800
+++ 4.0/source/scripts/engine_dmg.h	2011-10-11 21:55:07.666015600 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Classes and engine calls related to health, damage and repair
-	Copyright 2010 Jonathan Wilson, Mark Sararu, Joshua "NeoSaber" Kraft, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
